﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;

namespace SLTreeView
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            List<VMS_Info_Plate> _VMS_Info_PlateList = new List<VMS_Info_Plate>();

            for (int i = 1; i <= 5; i++)
            {
                _VMS_Info_PlateList.Add(new VMS_Info_Plate
                {
                    Info_class_id = i,
                    Info_class_code = i.ToString(),
                    Name = i.ToString(),
                    Parent_class_id = 0,
                    Class_level = 0,
                    InfoCount = 3
                });

                for (int j = 1; j <= 3; j++)
                {
                    _VMS_Info_PlateList.Add(new VMS_Info_Plate
                     {
                         Info_class_id = i * 10 + j,
                         Info_class_code = (i * 10 + j).ToString(),
                         Name = (i * 10 + j).ToString(),
                         Parent_class_id = i,
                         Class_level = 1,
                         InfoCount = 1
                     });
                }
            }

            AddTreeNode(0, null, _VMS_Info_PlateList);
        }

        #region 添加叶子节点信息
        /// <summary>
        ///  添加叶子节点信息
        /// </summary>
        /// <param name="parentID">父亲节点信息</param>
        /// <param name="treeViewItem"></param>
        private void AddTreeNode(Int32 parent_Code_Id, TreeViewItem treeViewItem, List<VMS_Info_Plate> _List)
        {
            // 检索查询的集合
            List<VMS_Info_Plate> result = _List.Where(A => A.Parent_class_id == parent_Code_Id).ToList();

            // 查询结果不为空
            if (result.Count > 0)
            {
                foreach (VMS_Info_Plate _InfoClassCount in result)
                {
                    TreeViewItem objTreeNode = new TreeViewItem();
                    //objTreeNode.Header = _InfoClassCount.Name + " ： " + _InfoClassCount.InfoCount + "条";
                    objTreeNode.DataContext = _InfoClassCount;
                    //objTreeNode.
                    ////此样式将会添加的所有叶子结点上
                    objTreeNode.Style = this.Resources["TreeViewItemStyle1"] as Style;

                    //添加根节点
                    if (treeViewItem == null)
                    {
                        ArtistTree.Items.Add(objTreeNode);
                    }
                    else
                    {
                        treeViewItem.Items.Add(objTreeNode);
                    }
                    AddTreeNode(_InfoClassCount.Info_class_id, objTreeNode, _List);
                }
                // 给父亲节点添加属性信息
                //objTreeNode.ItemContainerStyle = this.Resources["RedItemStyle"] as Style; 
            }
        }
        #endregion

        #region 信息类别
        /// <summary>
        /// 信息类别
        /// </summary>
        public class VMS_Info_Plate
        {
            /// <summary>
            /// 类别主键
            /// </summary>
            public Int32 Info_class_id { get; set; }

            /// <summary>
            /// 类别编号
            /// </summary>
            public String Info_class_code { get; set; }

            /// <summary>
            /// 类别名称
            /// </summary>
            public String Name { get; set; }

            /// <summary>
            /// 所属主类
            /// </summary>
            public Int32 Parent_class_id { get; set; }

            /// <summary>
            /// 类级别
            /// </summary>
            public Int32 Class_level { get; set; }

            /// <summary>
            /// 包含信息条数
            /// </summary>
            public Int32? InfoCount { get; set; }
        }
        #endregion
    }
}
